#include<stdio.h>
#include<math.h>
#include"calculation.h"

void DisplayVector(Vector *vec);
void DisplayMatrix(Matrix *mat);

int main()
{
	Vector *ans;
	Matrix *mat;

	ans = CreateVector(3);
	mat = CreateMatrix(3, 3);

	mat->a[0*mat->width + 0] = 3;
	mat->a[0*mat->width + 1] = 4;
	mat->a[0*mat->width + 2] = 5;

	mat->a[1*mat->width + 0] = 1;
	mat->a[1*mat->width + 1] = 1;
	mat->a[1*mat->width + 2] = 2;

	mat->a[2*mat->width + 0] = 1;
	mat->a[2*mat->width + 1] = 3;
	mat->a[2*mat->width + 2] = -1;

	ans->v[0] = 3;
	ans->v[1] = 1;
	ans->v[2] = 2;

	printf("Matrix:\n");
	DisplayMatrix(mat);

	printf("Vector:\n");
	DisplayVector(ans);

	FBSubstitution(mat, ans);

	printf("anser:\n");
	DisplayVector(ans);

	FreeVector(ans);
	FreeMatrix(mat);
}

void DisplayVector(Vector *vec)
{
	int i;

	for(i=0; i<vec->size; i++){
		printf("%f ", vec->v[i]);
	}
	printf("\n\n");
}

void DisplayMatrix(Matrix *mat)
{
	int i, j;

	for(i=0; i<mat->height; i++){
		for(j=0; j<mat->width; j++){
			printf("%f ", mat->a[i*mat->width + j]);
		}
		printf("\n");
	}
	printf("\n\n");
}
